function [lk,d1,D2] = lkxglom(nst,ncl,J,Z,b,mu,a,M,C)

% Computes log-likelihood, first derivative vector and 
% teh second derivative matrix
  t = 2^J-1;
  eta = Z*b;
  [la,pi,p,lap,pip,pp,D,Dp] = prob(nst,ncl,J,eta,a,M,C,2);
  lk = mu'*log(pp);
  d1 = Z'*Dp'*inv(diag(pp))*mu;
%  F = sum(sum(Y))/sum(p)*Z'*Dp'*inv(diag(pp))*Dp*Z;
  D2 = -Z'*Dp'*inv(diag(pp).^2)*diag(mu)*Dp*Z;


