function t = punt(m)

%        t = punt(m)
% - creates vector of scores
% - inputs:
% - m    : observed factors levels (those on the right run faster)
% - 
% - output:
% - t    : scores vector

% - preliminaries 
  nv = length(m);
  mcum = cumprod(m);
  n = mcum(nv);

% - for the constant and main factors
  t = [];
  for i=1:nv,
    M = [zeros(1,m(i)-1) ; eye(m(i)-1)];
    if i>1, M=kron (ones(mcum(i-1) , 1), M); end
    t = [t kron(M , ones(n/ mcum(i) ,1))];
  end
  t=sum(t')';